local dewdrop = AceLibrary("Dewdrop-2.0")
local SML = AceLibrary("SharedMedia-1.0")
local L = AceLibrary("AceLocale-2.2"):new("Proximo")
local test = false

local defaults = {
		scale=1,
		x=0,
		y=0,
		framecolor = {r = 0, g = 0, b = .1, a = 1},
		manacolor = {r = .18, g = .44, b = .75},
		highlightcolor = {r = 1, g = 1, b = 0},
		fontsize=16,
		padding=5,
		barheight=22,
		barwidth=200,
		header=true,
		focus=true,
		texture="Minimalist",
		font="Friz Quadrata TT",
		announce="disabled",
		ma=UnitName("player"),
		sync=true,
		partytargets = true,
		mana=true,
		highlight="solid",
}

function Proximo:GetDefaultConfig()
	return defaults
end

function Proximo:SetupOptions()
	SML:Register("statusbar", "Minimalist", "Interface\\Addons\\Proximo\\Textures\\Minimalist")
	self.options = { 
	  type="group",
	  args = {
	  	colors = {
	  		type="group",
	  		name=L["Colors"],
				desc=L["Colors"],
	  		order=1,
	  		args = {
			  	framecolor = {
			  		type="color",
						name=L["FrameColor"],
				    desc=L["FrameColor"],
				    get=function()
				        return self.db.profile.framecolor.r, self.db.profile.framecolor.g, self.db.profile.framecolor.b, self.db.profile.framecolor.a
				    end,
				    set=function(r, g, b, a)
				        self.db.profile.framecolor.r, self.db.profile.framecolor.g, self.db.profile.framecolor.b, self.db.profile.framecolor.a = r, g, b, a
					 			self:UpdateFrame()
				    end,
				    hasAlpha=true,
				    order=1,
					},
					manacolor = {
			  		type="color",
						name=L["ManaColor"],
				    desc=L["ManaColor"],
				    get=function()
				        return self.db.profile.manacolor.r, self.db.profile.manacolor.g, self.db.profile.manacolor.b
				    end,
				    set=function(r, g, b)
				        self.db.profile.manacolor.r, self.db.profile.manacolor.g, self.db.profile.manacolor.b = r, g, b
					 			self:UpdateFrame()
				    end,
				    hasAlpha=false,
				    order=2,
					},
					highlightcolor = {
			  		type="color",
						name=L["HighlightColor"],
				    desc=L["HighlightColor"],
				    get=function()
				        return self.db.profile.highlightcolor.r, self.db.profile.highlightcolor.g, self.db.profile.highlightcolor.b
				    end,
				    set=function(r, g, b)
				        self.db.profile.highlightcolor.r, self.db.profile.highlightcolor.g, self.db.profile.highlightcolor.b = r, g, b
					 			self:UpdateFrame()
				    end,
				    hasAlpha=false,
				    order=3,
					},
				},
			},
			frame = {
	  		type="group",
	  		name=L["Frame"],
				desc=L["Frame"],
	  		order=2,
	  		args = {
		  		fontsize = {
						type="range",
						name=L["FontSize"],
						desc=L["FontSize"],
						get=function() return self.db.profile.fontsize end,
			  		set=function(v) self.db.profile.fontsize = v 
			  			self:UpdateFrame()
			  		end,
						min=8,
						max=36,
						step=1,
						order=1,
			  	},
			  	font = {
						type = 'text',
						name = L["Font"],
						desc = L["Font"],
						validate = SML:List('font'),
						get=function() return self.db.profile.font end,
			  		set=function(v) self.db.profile.font = v 
			  			self:UpdateFrame()
			  		end,
			  		order=2,
					},
			  	barwidth = {
						type="range",
						name=L["BarWidth"],
						desc=L["BarWidth"],
						get=function() return self.db.profile.barwidth end,
			  		set=function(v) self.db.profile.barwidth = v 
			  			self:UpdateFrame()
			  		end,
						min=100,
						max=500,
						step=5,
						order=3,
			  	},
			  	barheight = {
						type="range",
						name=L["BarHeight"],
						desc=L["BarHeight"],
						get=function() return self.db.profile.barheight end,
			  		set=function(v) self.db.profile.barheight = v 
			  			self:UpdateFrame()
			  		end,
						min=10,
						max=40,
						step=1,
						order=4,
			  	},
			  	texture = {
						type = 'text',
						name = L["BarTexture"],
						desc = L["BarTexture"],
						validate = SML:List('statusbar'),
						get=function() return self.db.profile.texture end,
			  		set=function(v) self.db.profile.texture = v 
			  			self:UpdateFrame()
			  		end,
			  		order=5,
					},
					padding = {
						type="range",
						name=L["Padding"],
						desc=L["Padding"],
						get=function() return self.db.profile.padding end,
			  		set=function(v) self.db.profile.padding = v 
			  			self:UpdateFrame()
			  		end,
						min=1,
						max=30,
						step=1,
						order=6,
			  	},
					scale = {
						type="range",
						name=L["Scale"],
						desc=L["Scale"],
						get=function() return self.db.profile.scale end,
			  		set=function(v) self.db.profile.scale = v 
			  			self:UpdateFrame()
			  		end,
						min=0.1,
						max=3,
						step=0.1,
						order=7,
			  	},
			  	header = {
						type='toggle',
						name=L["Header"],
						desc=L["Header"],
						get=function() return self.db.profile.header end,
						set=function(v) self.db.profile.header = v 
			  			self:UpdateFrame()
			  		end,
						order=8,
					},
	  		},
	  	},
	  	misc = {
	  		type="group",
	  		name=L["Misc"],
				desc=L["Misc"],
	  		order=3,
	  		args = {
	  			focus = {
						type='toggle',
						name=L["Focus"],
						desc=L["Focus"],
						get=function() return self.db.profile.focus end,
						set=function(v) self.db.profile.focus = v 
			  			self:UpdateFrame()
			  		end,
						order=1,
					},
					sync = {
						type='toggle',
						name=L["Sync"],
						desc=L["SyncDesc"],
						get=function() return self.db.profile.sync end,
						set=function(v) self.db.profile.sync = v 
			  			self:UpdateFrame()
			  		end,
						order=2,
					},
					partytargets = {
						type='toggle',
						name=L["PartyTargets"],
						desc=L["PartyTargets"],
						get=function() return self.db.profile.partytargets end,
						set=function(v) self.db.profile.partytargets = v 
			  			self:UpdateFrame()
			  		end,
						order=3,
					},
					mana = {
						type='toggle',
						name=L["Mana"],
						desc=L["Mana"],
						get=function() return self.db.profile.mana end,
						set=function(v) self.db.profile.mana = v 
			  			self:UpdateFrame()
			  		end,
						order=4,
					},
					highlight = {
			  		type = "text",
						name = L["Hightlight"],
				    desc = L["Hightlight"],
				    get = function() return self.db.profile.highlight end,
				    set = function(v) self.db.profile.highlight = v 
				    	self:UpdateFrame()
				    end,
				    validate = {
				    	solid = L["HightlightSolid"],
					    tooltip = L["HightlightTooltip"],
						},
						order = 5,
					},
					announce = {
			  		type = "text",
						name = L["Announce"],
				    desc = L["Announce"],
				    get = function() return self.db.profile.announce end,
				    set = function(v) self.db.profile.announce = v end,
				    validate = {
				    	chat = CHAT_LABEL,
					    raid = CHAT_MSG_RAID_WARNING,
							sct = "SCT",
							msbt = "MSBT",
							disabled = "Disabled",
						},
						order = 6,
					},
	  		},
	  	},
			ma = {
				type = 'text',
				name = L["MainAssist"],
				desc = L["MainAssist"],
				usage = "<name>",
				get=function() return self.db.profile.ma end,
	  		set=function(v) self.db.profile.ma = v 
	  			self:SetMainAssist(v)
	  			self:SendCommMessage("GROUP", "ReceiveMainAssist", v)
	  			self:Print(L["MainAssist"]..": "..v)
	  		end,
	  		order=4,
			},
			test = {
				type='toggle',
				name=L["Test"],
				desc=L["TestDesc"],
				get=function() return test end,
				set=function(v)
					test = v
					if v then 
						if self.frame==nil then
							self:MakeFrame()
						end
						self.frame:Show()
						self:Test()
					else 
						self:ResetList()
						self.frame:Hide()
					end 
				end,
				order=5,
			},
		}
	}
end

local function DewDropOptions()
  dewdrop:AddLine('text', 'Proximo Options','isTitle', true)
	dewdrop:InjectAceOptionsTable(Proximo, Proximo.options)
	dewdrop:FeedAceOptionsTable(Proximo.options)
end

function Proximo:DewDropMenu() 
	dewdrop:Open(Proximo.frame, 'children', DewDropOptions, 'cursorX', true, 'cursorY', true)
end